<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: models/index.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: models/index.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
const SequelizeStatic = require("sequelize");
const Config_1 = require("../config/Config");
const Logger_1 = require("../utils/Logger");
/**
 * Configures the database according to the provided configuration. &lt;/br>
 * Imports the models and associations.
 * @class
 * @author Farooq Ilyas
 */
class Database {
    /**
     * @constructor
     */
    constructor() {
        this.basename = path.basename(module.filename);
        let dbConfig = Config_1.configs.getDatabaseConfig();
        this.setLogging(dbConfig);
        this.configureUserDatabase(dbConfig);
        this.importUserModels();
    }
    /**
     * Sets the level of logging for the database as per the configuration.
     * @param {DatabaseConfig} dbConfig database configuration
     */
    setLogging(dbConfig) {
        if (dbConfig.logging) {
            dbConfig.logging = Logger_1.logger.info;
        }
    }
    /**
     * Creates the database connection
     * @param {DatabaseConfig} dbConfig database configuration
     */
    configureUserDatabase(dbConfig) {
        this.sequelize = new SequelizeStatic('sqlite:///:memory:');
        this.models = {};
    }
    /**
     * Imports the models and their associations and
     * associates them with the connection
     */
    importUserModels() {
        fs.readdirSync(__dirname).filter((file) => {
            return (file !== this.basename) &amp;&amp; (file !== "interfaces");
        }).forEach((file) => {
            let model = this.sequelize.import(path.join(__dirname, file));
            this.models[model.name] = model;
        });
        Object.keys(this.models).forEach((modelName) => {
            if (typeof this.models[modelName].associate === "function") {
                this.models[modelName].associate(this.models);
            }
        });
    }
    /**
     * Returns the models
     * @returns {SequelizeModels} models
     */
    getModels() {
        return this.models;
    }
    /**
     * Returns the database connection
     * @returns {SequelizeStatic.Sequelize} database connection
     */
    getSequelize() {
        return this.sequelize;
    }
}
const database = new Database();
exports.models = database.getModels();
exports.sequelize = database.getSequelize();
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="BaseRouter.html">BaseRouter</a></li><li><a href="Configs.html">Configs</a></li><li><a href="CustomErrorHandler.html">CustomErrorHandler</a></li><li><a href="Database.html">Database</a></li><li><a href="DBConfig.html">DBConfig</a></li><li><a href="LoggingConfiguration.html">LoggingConfiguration</a></li><li><a href="Middleware.html">Middleware</a></li><li><a href="Server.html">Server</a></li><li><a href="ServerConfiguration.html">ServerConfiguration</a></li><li><a href="UserController.html">UserController</a></li><li><a href="UserModel.html">UserModel</a></li><li><a href="UserRouter.html">UserRouter</a></li><li><a href="UserService.html">UserService</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Mon Jul 02 2018 23:16:09 GMT+0100 (GMT Daylight Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
